
/*
 *          |          _                     _______________________
 *          |\       _/ \_                  |                       |
 *          | \_    /_    \_                |    Alexandre Botao    |
 *          \   \__/  \__   \               |     www.botao.org     |
 *           \_    \__/  \_  \              |    55-11-8244-UNIX    |
 *             \_   _/     \ |              |  alexandre@botao.org  |
 *               \_/        \|              |_______________________|
 *                           |
 */

/*______________________________________________________________________
 |                                                                      |
 |  This code is free software: you can redistribute it and/or modify   |
 |  it under the terms of the GNU General Public License as published   |
 |  by the Free Software Foundation, either version 3 of the License,   |
 |  or (at your option) any later version.                              |
 |                                                                      |
 |  This code is distributed in the hope that it will be useful,        |
 |  but WITHOUT ANY WARRANTY; without even the implied warranty of      |
 |  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                |
 |  See the GNU General Public License for more details.                |
 |                                                                      |
 |  You should have received a copy of the GNU General Public License   |
 |  along with this code.  If not, see <http://www.gnu.org/licenses/>,  |
 |  or write to the Free Software Foundation, Inc.,                     |
 |  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.            |
 |______________________________________________________________________|
 */

# ifndef _BUD_H_

# define _BUD_H_

/*	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	*/

#ifdef LNX
# if ( ( ! defined (UBUNTU) ) && ( ! defined (SUSE) ) )
#    error "must define {UBUNTU|SUSE}"
# endif /* ! def OS */
#endif

/*	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	*/

# if defined (UBUNTU) || defined (SUSE)
#	define	ANYX
#	define	LINUX
#	define	USE_LINUX_FS
#	define	USE_ASM_TIOS
#	define	VPTRVOID
#	define	PROTOIOCTL
# endif

# if defined (CYGWIN)
#	define	ANYX
#	define	USE_CYGWIN_FS
#	define	USE_SYS_TIOS
#	define	PROTOIOCTL
# endif

# if defined (HPUX)
#	include <stropts.h>
#	include <sys/scsi.h>
#	include <sys/diskio.h>
#	define	ANYX
#	define	USE_TIOS
#	define	USE_FCNTL
#	define	DEFMAXMIN
# endif

# if defined (SOLARIS) || defined (SUNX)
#	include <sys/ioctl.h>
#	include <sys/dkio.h>
#	include <sys/vtoc.h>
#	define	ANYX
#	define	USE_FCNTL
#	define	NOLOG2
/* # define USE_DSKGEO */ /* preferably */
#	if ( ( ! defined (USE_DSKGEO) ) && ( ! defined (USE_MEDINF) ) )
#		error "must define USE_{DSKGEO|MEDINF}"
#	endif /* ! def DKIODGMI */
# endif

# if defined (AIX)
#	include <sys/ioctl.h>
#	include <sys/devinfo.h>
#	include <sys/lvdd.h>
#	define	ANYX
#	define	USE_FCNTL
# endif

# if defined (FREEBSD) /* || defined (FreeBSD) */
#	include <sys/ioctl.h>
#	include <sys/disk.h>
#	define	ANYX
#	define	BSD
#	define	NOLOG2
# endif

# if defined (APPLE)
#	include <stdint.h>
#	include <sys/ioctl.h>
#	include <sys/disk.h>
#	define	ANYX
# endif

/*	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	*/

# ifdef USE_FCNTL
#	include <fcntl.h>
# endif

# ifdef USE_TIOS
#	include <termios.h>
# endif

# ifdef USE_ASM_TIOS
#	include <asm/termios.h>
# endif

# ifdef USE_SYS_TIOS
#	include <sys/termios.h>
# endif

# ifdef USE_CYGWIN_FS
# include	<cygwin/fs.h>
# endif

# ifdef USE_LINUX_FS
# include	<linux/fs.h>
# endif

/*	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	*/

# ifdef		ANSI
#	define				ARGLST(X)	X
#	define				OF(X)	X
# else		/* OLD */
#	define				ARGLST(X)	()
#	define				OF(X)	()
# endif		/* ANSI */

# ifndef ULONG
# define ULONG	unsigned long
# endif

long long	bunitz	ARGLST ( char * ) ;

/*	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	*/

# include "logdmp.h"
# include "tvus.h"
# include "simio.h"
# include "xalloc.h"
/*
# include "objlst.h"
# include "stdtyp.h"
 */
# include "stdasc.h"
# include "stdmisc.h"

/*	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	*/

# ifdef LINUX
/*
# define	_GNU_SOURCE
double log2 (double) ;
 */
# endif

# ifdef		DEFMAXMIN
# define	LLONG_MAX	9223372036854775807LL
# define	LLONG_MIN	(-LLONG_MAX - 1LL)

# define	FLOAT_MAX	((float)3.40282346638528860e+38)
# define	FLOAT_MIN	((float)1.40129846432481707e-45)
# endif

# define	DOUBLE_MAX	1.79769313486231570e+308
# define	DOUBLE_MIN	4.94065645841246544e-324

#ifdef NOLOG2
# define log2(N) (log(N)/log(2)) /* log2(n) = ln(n)/ln(2) = log(n)/log(2) */
#endif

/*	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	__	*/

# endif /* ! _BUD_H_ */

/*
 *	vi:nu ts=4
 */
