
/*
 *          |          _                     _______________________
 *          |\       _/ \_                  |                       |
 *          | \_    /_    \_                |    Alexandre Botao    |
 *          \   \__/  \__   \               |     www.botao.org     |
 *           \_    \__/  \_  \              |    55-11-8244-UNIX    |
 *             \_   _/     \ |              |  alexandre@botao.org  |
 *               \_/        \|              |_______________________|
 *                           |
 */

/*______________________________________________________________________
 |                                                                      |
 |  This code is free software: you can redistribute it and/or modify   |
 |  it under the terms of the GNU General Public License as published   |
 |  by the Free Software Foundation, either version 3 of the License,   |
 |  or (at your option) any later version.                              |
 |                                                                      |
 |  This code is distributed in the hope that it will be useful,        |
 |  but WITHOUT ANY WARRANTY; without even the implied warranty of      |
 |  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                |
 |  See the GNU General Public License for more details.                |
 |                                                                      |
 |  You should have received a copy of the GNU General Public License   |
 |  along with this code.  If not, see <http://www.gnu.org/licenses/>,  |
 |  or write to the Free Software Foundation, Inc.,                     |
 |  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.            |
 |______________________________________________________________________|
 */

# include <stdio.h>

# include "tvus.h"

long long diftod (tvp1, tvp2) struct timeval * tvp1, * tvp2 ; {

# ifdef ORIG
	long long sec1, sec2, usec1, usec2, d ;

	sec1 = tvp1->tv_sec ;
	sec2 = tvp2->tv_sec ;
	usec1 = tvp1->tv_usec ;
	usec2 = tvp2->tv_usec ;

	d = (1000000 * (sec2 - sec1)) + (usec2 - usec1) ;

	return d ;
# else
	struct timeval tv3 ;

	tv3.tv_sec = tvp2->tv_sec - tvp1->tv_sec ;
	tv3.tv_usec = tvp2->tv_usec - tvp1->tv_usec ;
	if (tv3.tv_usec < 0) {
		--tv3.tv_sec ;
		tv3.tv_usec += 1000000 ;
	}
	return (long long) ( ( 1000000 * tv3.tv_sec ) + tv3.tv_usec ) ;
# endif

}

char * fmtus (t) long long t ; {

	long long u, s, m, h ;
	static char b [64] ;

	u = t % 1000000 ;
	s = t / 1000000 ;
	m = s / 60 ;
	h = m / 60 ;

	sprintf (b, "%02lld:%02lld:%02lld:%06lld", h, m, s, u) ;

	return b ;
}

